<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>make - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="install.html">install</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="install.html#.install_as_user">install_as_user</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_as_developer">install_as_developer</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_a_new_package">install_a_new_package</a></li></ul></li><li><a href="make.html">make</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="make.html#.build">build</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_cpp">build_cpp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_gyp">build_gyp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_python">build_python</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_public">build_public</a></li><li data-type='method' style='display: none;'><a href="make.html#.test">test</a></li><li data-type='method' style='display: none;'><a href="make.html#.clean">clean</a></li><li data-type='method' style='display: none;'><a href="make.html#.sync">sync</a></li><li data-type='method' style='display: none;'><a href="make.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="make.html#.usage">usage</a></li><li data-type='method' style='display: none;'><a href="make.html#.install">install</a></li></ul></li><li><a href="jsdoc2.html">jsdoc2</a></li></ul><h3>Global</h3><ul><li><a href="global.html#make-readme">make-readme</a></li><li><a href="global.html#menu">menu</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">make</h1>
    

    




<section>

<header>
    
        <h2>
        
            make
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="make"><span class="type-signature"></span>factory make<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Describes the different make directives.</p>
<p>This allows to compile C/C++ code as middleware for Javascript or Python.</p>
<ul>
<li>
<p>The package meta-data is stored in the <code>./package.json</code> file, created at initialization, as detailed <a href="./install.html#.install_a_new_package">here</a>.</p>
</li>
<li>
<p>Source files are in the <code>./src</code> directory.</p>
</li>
<li>
<p>Target files are in the:</p>
<ul>
<li><code>./public/</code> directory for all documentation and downloadable web files.</li>
<li><code>./node_modules/</code> and <code>./build/</code> directories for all compiled or interpreted third-party used files.</li>
</ul>
</li>
<li>
<p>The MODULE makefile  variable is set and set to true if the package is used as dependendy of another package.</p>
</li>
<li>
<p>Do not edit:</p>
<ul>
<li><code>README.md</code> in the package root directory, it is generated by <a href="#.build_public">build</a> from <code>package.json</code>.</li>
<li><code>package-lock.json</code> in the package root directory, it is used to manage <code>node_modules</code> packages.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".build"><span class="type-signature type-signature-static">(static) </span>build<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Build all target files from source files.</p>
<ul>
<li>
<p>This corresponds to the <code>npm run build</code> command in the <code>package.json</code> file.</p>
</li>
<li>
<p>User defined build commands are defined in the makefile BUILD variable.</p>
</li>
<li>
<p>This command <a href="#.build_cpp">compiles C/C++ files</a> if any, <a href="#.build_gyp">installs node-gyp files</a> if used, <a href="#.build_python">builds the python wrapper</a> if relevant, <a href="#.build_public">generates documentation files</a> if possible, and finally builds all target files specified in the <code>BUILD</code> variable of the <code>makefile</code> file.</p>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".build_cpp"><span class="type-signature type-signature-static">(static) </span>build_cpp<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Compiles C/C++ files if any.</p>
<h2>Organization of the files and directories</h2>
<ul>
<li>
<p>C/C++ headers are stored in <code>.hpp</code> files.</p>
</li>
<li>
<p>C/C++ sources yielding library routines are stored in <code>.cpp</code> files.</p>
</li>
<li>
<p>C/C++ main file sources yielding executables are stored in <code>.C</code> files.</p>
</li>
<li>
<p>C/C++ template file sources not taken into account unless explicitely included are stored in <code>.tpp</code> files.</p>
</li>
<li>
<p>Target files are stored:</p>
<ul>
<li>in the <code>./node_modules/.inc</code> directory for C/C++ include header files of libraries.</li>
<li>in the <code>./node_modules/.lib</code> directory for static C/C++ compiled libraries.</li>
<li>in the <code>./node_modules/.bin</code> directory for binary executable files.</li>
</ul>
</li>
<li>
<p>The <code>&quot;build_cpp&quot;: false</code> directive in the <code>package.json</code> file prevents to compile C/C++ code, even if any.</p>
</li>
<li>
<p>Here we build static <code>./node_modules/.lib/lib$name.a</code> libraries to simplify the link phase and a better compatibility.</p>
</li>
<li>
<p>A recommended <code>test.C</code> file implements functional and non-regression tests.</p>
<ul>
<li>Tests are run in the top level directory (not in <code>./src</code>).</li>
<li>The <a href="#.test"><code>make test</code></a> commands compiles and run the tests.</li>
<li>The tests are compiled in the <code>../node_modules/.bin/test</code> executable.</li>
</ul>
</li>
</ul>
<h2>Compilation options</h2>
<p>Compilation options include the compiler choice, compilation flags, include directories, precompiled library directories and names, to be defined in the <code>./src/makefile</code> following the given model:</p>
<pre class="prettyprint source"><code>CXX      = c++                           # 'CXX'          : defines the C/C++ compiler
CCFLAGS  = -$option                      # 'defines'      : compilation options
INCDIRS  = -I$include_dir ...            # 'include_dirs' : source header directories
LIBDIRS  = -L$library_dir ...            # 'library_dirs' : precompiled library directories
LIBS     = -l$library ...                # 'libraries'    : libraries to link with the code
AIDEDEPS = aidesys                       # 'AIDEDEPS'     : other aidebuild packages dependencies
</code></pre>
<ul>
<li>
<p>The <code>CCFLAGS</code> and <code>INCDIRR</code> are used for source file compilation.</p>
</li>
<li>
<p>The <code>LIBDIRS</code> and <code>LIBS</code> are used for executable linking.</p>
</li>
<li>
<p>The <code>AIDEDEPS</code> list aidebuild packages dependencies, allowing to automatically builds them.</p>
</li>
<li>
<p><em>Note</em>: Actually the <code>-std=c++17</code> C++ standard is in use.</p>
</li>
</ul>
<h2>Compiling with an alternative compiler</h2>
<p>Using this piece of makefile it is possible to erase all C/C++ compilation and recompile with an alternative compiler,
here using, for instance, the usual MacOS clang compiler.</p>
<pre class="prettyprint source"><code>export CXX = clang++

recompile:
 /bin/rm -rf ../node_modules/.lib/*.a ../node_modules/.bin/test
 make test
</code></pre>
<h2>Development hints</h2>
<ul>
<li>This command allows to identified undefined symbols (i.e., defined in a .hpp fils but not implemented in a .cpp file)</li>
</ul>
<pre class="prettyprint source"><code>nm -C --demangle --undefined-only ../node_modules/.lib/$module_name.a | grep $module_name
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".build_gyp"><span class="type-signature type-signature-static">(static) </span>build_gyp<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Compiles the node-gyp wrapper files, in order use the code via a web service.</p>
<ul>
<li>
<p>The node-gyp wrapping allows to use C/C++ source in a Javascript server side node express utilities for web applications and services.</p>
</li>
<li>
<p>It is based on <a href="https://gyp.gsrc.io/index.md">gyp</a> and <a href="https://nodejs.org/api/n-api.html">napi</a>.</p>
</li>
<li>
<p>It is detailed in the <a href="https://line.gitlabpages.inria.fr/aide-group/aideweb">aideweb package</a>, which is a root package for such functionality, e.g. using a <a href="https://line.gitlabpages.inria.fr/aide-group/aideweb/WrapperCCService.html">WrapperCCService</a>.</p>
</li>
<li>
<p>It is recommended to install <code>gyp</code> globally, to save local space, i.e. run:</p>
</li>
</ul>
<pre class="prettyprint source"><code>sudo npm install -g node-gyp
</code></pre>
<ul>
<li>
<p>You may also run <code>sudo npm install -g bindings express express-fileupload node-addon-api</code> instead of locally.</p>
</li>
<li>
<p>The <code>&quot;gypfile&quot;: true</code> directive in the <code>package.json</code> file enables <code>node-gyp</code> built.</p>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".build_python"><span class="type-signature type-signature-static">(static) </span>build_python<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Builds a python wrapper for the local C/C++ source code and its dependencies.</p>
<ul>
<li>It is based on <a href="http://www.swig.org">swig</a> and available as a user adaptable <a href="https://gitlab.inria.fr/line/aide-group/aidebuild/-/blob/master/src/python_wrapper.sh">script</a>.</li>
<li>The <code>&quot;swig&quot;: true</code> directive in the <code>package.json</code> file enables building the python wrapper.</li>
<li>The python 3.10 and 3.11 versions are actually usable, easily adaptable to others.</li>
</ul>
<h2>Development hints</h2>
<ul>
<li>In the makefile, you likely have to explicitly list, in the right order, used *.hpp files used by other files because the default .hpp order is random. This is to be done in the PY_HPP file, e.g.,</li>
</ul>
<pre class="prettyprint source"><code>PY_HPP=&quot;../node_modules/wjson/src/Value.hpp ../..&quot;
</code></pre>
<p>A minimal python wrapping is exemplified in this <a href="https://gitlab.inria.fr/line/aide-group/aidesys/-/blob/master/src/test.py"><code>test.py</code></a> file.</p>
<ul>
<li>In order to avoid, in <code>.hpp</code> or <code>.cpp</code> file, to take python incompatible pieces of code (e.g., C++ operator) into account a construct of the form can be used:</li>
</ul>
<pre class="prettyprint source"><code>#ifndef SWIG
// Here is code not to be wrapped for python by swig
#endif
</code></pre>
<ul>
<li>
<p>As for usual C/C++ compilation <code>.hpp</code> and <code>.cpp</code> files are taken into account but <code>.tpp</code> are not unless explicitly included.</p>
</li>
<li>
<p>The makefile specifies the <code>PYTHONPATH</code> environment variable allowing to load the defined modules</p>
</li>
</ul>
<pre class="prettyprint source"><code>export PYTHONPATH += :../build/python/site-packages
</code></pre>
<ul>
<li>Since SWIG does NOT consider namespace, all objects are prefixed with the compiled module name, e.g.:</li>
</ul>
<pre class="prettyprint source"><code>python
>>> import wjson
>>> wjson.alert(True, &quot;&quot;, &quot;Looks fine&quot;) # even if aidesys::alert comes not from wjson but the aidesys namespace
</code></pre>
<ul>
<li>A recommended <code>test.py</code> file implements functional and non-regression tests.
<ul>
<li>Tests are run in the top level directory (not in <code>./src</code>).</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".build_public"><span class="type-signature type-signature-static">(static) </span>build_public<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Compiles all documentation and downloadable web files.</p>
<ul>
<li>
<p>This generates a HTML documentation in the <code>./public</code> directory and generates the <code>README.md</code>.</p>
</li>
<li>
<p>Refer for <a href="./jsdoc2.html">jsdoc2</a> for a presentation of the general mechanism.</p>
</li>
<li>
<p>The following generation process is performed:</p>
<ul>
<li>The <code>README.md</code> file in automatically generated from the <code>package.json</code> and beyond standard meta-data options:
<ul>
<li>An optional <code>introduction.md</code> allows to present the package in the README beyond meta-data presentation</li>
<li>An optional <code>usage</code> section in the <code>package.json</code> as <a href="https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/package.json">exemplified here</a> allows to add a sequence of HTML lines to described the package usage.</li>
</ul>
</li>
<li>All <code>.hpp</code> <code>.js</code> <code>.sh</code>, source files are parsed using <a href="https://jsdoc.app">jsdoc</a> in order to generate the relative documentation files.
<ul>
<li>Please refer as a <code>.hpp</code> example to <a href="https://gitlab.inria.fr/line/aide-group/aidesys/-/blob/master/src/file.hpp">this file</a> and notice that the documentation is completely separated from the C/C++ code, which is not parsed by jsdoc.</li>
<li>Please refer as a <code>.js</code> example to <a href="https://gitlab.inria.fr/line/aide-group/wjson/-/blob/master/src/wJSON.js">this file</a>.</li>
<li>Please refer as a <code>.sh</code> example to <a href="https://gitlab.inria.fr/line/aide-group/aidesys/-/blob/master/src/python_wrapper.sh">this file</a> noticing that documentation lines are prefixed with <code>#</code>.</li>
</ul>
</li>
<li>All <code>.js</code> <code>.css</code> <code>.hpp</code> <code>.cpp</code> <code>.sh</code> are shared after being beautified in order to have a standard format and normalized presentation.</li>
<li>Broken links are detected.</li>
</ul>
</li>
<li>
<p>The following complementary files are processed:</p>
<ul>
<li>All <code>.js</code> and <code>.css</code> are compacted and copied in order to be optimally downloaded.</li>
<li>All <code>.html</code>, and <code>.png</code>, <code>.jpg</code>, <code>.gif</code> images are copied in the public directory.</li>
<li>Any <code>.odg</code> drawing is translated to <code>.png</code> if <code>libreoffice</code> is installed, and the source is copied.</li>
<li>Any <code>.tex</code> (except <code>*.inc.tex</code> input file that only to be included) section file is
<ul>
<li>concatenated to this <a href="https://gitlab.inria.fr/line/aide-group/aidebuild/-/blob/master/src/tex/preamble.tex">preamble</a> to be compiled as a <code>.pdf</code> file;</li>
<li>with a bibliography using <code>.bib</code> file added if any <code>\cite{…}</code> command are present;</li>
<li>usually structured in <code>\subsection</code> to be reused in larger documents,
<ul>
<li>you may refer to this <a href="https://gitlab.inria.fr/line/aide-group/symboling/-/blob/master/src/symboling.tex">source example</a> compiled <a href="https://line.gitlabpages.inria.fr/aide-group/symboling/symboling.pdf">here</a>.</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li>
<p>Any <code>.mpl</code>, i.e., <a href="https://www.maplesoft.com">maple</a>, file is executed in the <code>./public</code> directory to generate optional graphic or text files, as programmed in the the maple source code.</p>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".test"><span class="type-signature type-signature-static">(static) </span>test<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Runs functional and non-regression tests.</p>
<ul>
<li>
<p>This corresponds to the <code>npm test</code> command in the <code>package.json</code> file.</p>
</li>
<li>
<p>The following tests are performed in this order:</p>
<ul>
<li>The <code>test.sh</code> file, if any, is run with <code>bash</code>.</li>
<li>The <code>test.C</code> file, if any, contains a <code>int main()</code> routine and is compiled and executed for test
<ul>
<li><code>make test ARGV=&quot;arg1... &quot;</code> runs interactive tests.
<ul>
<li>Tip: run <code>make test ARGV=&quot;-i&quot;</code> if no special options for interactive tests.</li>
</ul>
</li>
<li><code>make gtest [ARGV=&quot;arg1... &quot;]</code> runs C/C++ tests via <a href="https://www.sourceware.org/gdb/">gdb</a>, in order to observe debugging information.</li>
<li><code>make vtest [ARGV=&quot;arg1... &quot;]</code> runs C/C++ tests via <a href="https://valgrind.org/">valgrind</a>, with standard options, in order to observe debugging information.</li>
</ul>
</li>
<li>The <code>test.js</code> file, if any, is run with <code>node</code>.</li>
<li>The <code>test.html</code> file, if any, is opened using current<code> $BROWSER</code> defined browser to run tests via HTML code.</li>
<li>User defined test commands defined in the makefile TEST variable.</li>
</ul>
</li>
</ul>
<p><em>Note</em>: By contract, the <code>test.sh</code>, <code>test.js</code> and <code>test.cpp</code> files run automatically if no argument and in interactive mode if any argument, e.g.:</p>
<pre class="prettyprint source"><code> make -C ./src test ARGV=&quot;arg1 ...&quot;
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".clean"><span class="type-signature type-signature-static">(static) </span>clean<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Cleans installation files.</p>
<ul>
<li>
<p>This corresponds to the <code>npm run clean</code> command in the <code>package.json</code> file.</p>
</li>
<li>
<p>Removes the ./node_modules, ./build and ./package-lock.json directory and file.</p>
</li>
<li>
<p>Runs the <code>./src/clean.sh</code> script if any if order to perform additional clean operation.</p>
</li>
<li>
<p>The makefile <code>CLEAN</code> variable allows to define additional clean targets.</p>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".sync"><span class="type-signature type-signature-static">(static) </span>sync<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Syncs, thus publishes, the files with respect to the git repository, and get the npmjs repository status.</p>
<ul>
<li>Runs git pull, commit and push with default options and no commit message (which is only acceptable for preliminary development or minor changes not worth documenting them).</li>
</ul>
<h3>Publishing and archiving</h3>
<ul>
<li>
<p>To publish on <a href="https://www.npmjs.com">https://www.npmjs.com</a>:</p>
<ul>
<li>Set the <code>package.json</code> boolean field <code>&quot;npm_publish&quot;: true</code> to indicate that the software has been published.</li>
<li><a href="https://www.npmjs.com/signup">Sign up</a> or <a href="https://www.npmjs.com/login">Sign in</a>.</li>
<li>In the package root directory with <code>package.json</code>:
<ul>
<li><code>npm adduser</code> to connect the package to the account,</li>
<li><code>npm publish --access-public</code> to publish, while precisions are given if required.</li>
</ul>
</li>
</ul>
</li>
<li>
<p>To update a published package on <code>https://www.npmjs.com</code>:</p>
<ul>
<li>Properly update the version number in <code>package.json</code> according to <a href="https://docs.npmjs.com/about-semantic-versioning">semantic-versioning</a>.</li>
<li>In the package root directory run <code>npm publish</code>.</li>
</ul>
</li>
<li>
<p><em>Managing conflicts</em>: most ofter conflicts are related to generated files, using <a href="https://www.git-scm.com/docs/merge-options#Documentation/merge-options.txt---autostash"><code>git merge --autostash</code></a> (with care) solves the conflict, preserving local source changes.</p>
</li>
<li>
<p>To  archived on <a href="https://archive.softwareheritage.org">https://archive.softwareheritage.org</a></p>
<ul>
<li>Set the <code>package.json</code> boolean field <code>&quot;softwareheritage&quot;: true</code> to indicate that the software has been archived.</li>
<li>Use <a href="https://archive.softwareheritage.org/save/list/">this link</a> to save it.
<ul>
<li>Enter <code>git</code> in <code>Origin type</code></li>
<li>Enter the documentation link, e.g. <code>https://gitlab.inria.fr/line/aide-group/$projet-name</code> in <code>Origin Url</code></li>
</ul>
</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".show"><span class="type-signature type-signature-static">(static) </span>show<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Opens the documentation page using the current defined browser in the $BROWSER variable.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".usage"><span class="type-signature type-signature-static">(static) </span>usage<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Shows the makefile usage, which is the default operation unless the makefile defined another.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".install"><span class="type-signature type-signature-static">(static) </span>install<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Installs specific any source file (this is usually not called directly).</p>
<ul>
<li>When the <code>npm install</code> command is run, after npm installation, it runs &quot;make -s -C ./src install&quot; which:
<ul>
<li>Updates the <code>.src/.makefile.inc</code> file with all the instruction defined here to use a fresh version.</li>
<li>Constructs any target specified in the makefile <code>INSTALL</code> variable in order to perform additional install operation.</li>
<li>Runs the <code>./src/install.sh</code> script if any if order to perform additional install operation.</li>
</ul>
</li>
</ul>
<p><em>Remark</em>: In order to initialize a package directory, runs the <a href="./install.html#.install_a_new_package">init</a> script.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>